using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace voql
{
	/// <summary>
	/// Summary description for QueryDialog.
	/// </summary>
	internal class QueryDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.ToolBarButton toolBarButtonOpen;
		private System.Windows.Forms.ToolBarButton toolBarButtonSave;
		private System.Windows.Forms.ToolBarButton toolBarButton1;
		private System.Windows.Forms.ToolBarButton toolBarButtonHelp;
		private System.Windows.Forms.ToolBarButton toolBarButtonSQL;
		private System.Windows.Forms.ToolBarButton toolBarButtonResult;
		private System.Windows.Forms.ToolBarButton toolBarButton2;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.HelpProvider helpProvider1;
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.DataGrid dataGridQueryResult;
		private System.Windows.Forms.RichTextBox textBoxSQL;
		private System.Windows.Forms.RichTextBox textBoxQuery;
		private System.Windows.Forms.ImageList imageListToolBar;
		private System.Windows.Forms.ImageList imageListTreeView;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.ToolBarButton toolBarButtonShowModel;
        private System.Windows.Forms.ToolBarButton toolBarButton3;
        private ToolBarButton toolBarButtonReload;
        private ToolBarButton toolBarButton5;
        private ContextMenuStrip contextMenuStrip1;
        private ToolStripMenuItem toolStripMenuItemCopyNodeText;
		private System.ComponentModel.IContainer components;

		public QueryDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.textBoxQuery.KeyDown += new KeyEventHandler(QueryDialog_KeyDown);
			this.textBoxSQL.KeyDown   += new KeyEventHandler(QueryDialog_KeyDown);
			ShowModel();
			this.textBoxQuery.Focus();
			this.treeView1.ItemDrag += new ItemDragEventHandler(treeView1_ItemDrag);
            this.textBoxQuery.DragEnter += new DragEventHandler(textBoxQuery_DragEnter);
            this.textBoxQuery.DragDrop += new DragEventHandler(textBoxQuery_DragDrop);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				this.textBoxQuery.KeyDown -= new KeyEventHandler(QueryDialog_KeyDown);
				this.textBoxSQL.KeyDown   -= new KeyEventHandler(QueryDialog_KeyDown);

				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(QueryDialog));
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.toolBarButtonOpen = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonSave = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonSQL = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonResult = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton2 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonShowModel = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton3 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonReload = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton5 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonHelp = new System.Windows.Forms.ToolBarButton();
			this.imageListToolBar = new System.Windows.Forms.ImageList(this.components);
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.contextMenuStrip1 = new System.Windows.Forms.ContextMenuStrip(this.components);
			this.toolStripMenuItemCopyNodeText = new System.Windows.Forms.ToolStripMenuItem();
			this.imageListTreeView = new System.Windows.Forms.ImageList(this.components);
			this.dataGridQueryResult = new System.Windows.Forms.DataGrid();
			this.textBoxSQL = new System.Windows.Forms.RichTextBox();
			this.textBoxQuery = new System.Windows.Forms.RichTextBox();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.helpProvider1 = new System.Windows.Forms.HelpProvider();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.panel4 = new System.Windows.Forms.Panel();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.contextMenuStrip1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dataGridQueryResult)).BeginInit();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.panel3.SuspendLayout();
			this.panel4.SuspendLayout();
			this.SuspendLayout();
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.toolBarButtonOpen,
            this.toolBarButtonSave,
            this.toolBarButton1,
            this.toolBarButtonSQL,
            this.toolBarButtonResult,
            this.toolBarButton2,
            this.toolBarButtonShowModel,
            this.toolBarButton3,
            this.toolBarButtonReload,
            this.toolBarButton5,
            this.toolBarButtonHelp});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageListToolBar;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(707, 28);
			this.toolBar1.TabIndex = 0;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// toolBarButtonOpen
			// 
			this.toolBarButtonOpen.ImageIndex = 0;
			this.toolBarButtonOpen.Name = "toolBarButtonOpen";
			this.toolBarButtonOpen.ToolTipText = "Open Query File (Ctrl+O)";
			// 
			// toolBarButtonSave
			// 
			this.toolBarButtonSave.ImageIndex = 1;
			this.toolBarButtonSave.Name = "toolBarButtonSave";
			this.toolBarButtonSave.ToolTipText = "Save Query in  File (Ctrl+S)";
			// 
			// toolBarButton1
			// 
			this.toolBarButton1.Name = "toolBarButton1";
			this.toolBarButton1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButtonSQL
			// 
			this.toolBarButtonSQL.ImageIndex = 4;
			this.toolBarButtonSQL.Name = "toolBarButtonSQL";
			this.toolBarButtonSQL.ToolTipText = "Generate SQL String (F5)";
			// 
			// toolBarButtonResult
			// 
			this.toolBarButtonResult.ImageIndex = 3;
			this.toolBarButtonResult.Name = "toolBarButtonResult";
			this.toolBarButtonResult.ToolTipText = "Execute Query and Display Result (Ctrl+F5)";
			// 
			// toolBarButton2
			// 
			this.toolBarButton2.Name = "toolBarButton2";
			this.toolBarButton2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButtonShowModel
			// 
			this.toolBarButtonShowModel.ImageIndex = 5;
			this.toolBarButtonShowModel.Name = "toolBarButtonShowModel";
			this.toolBarButtonShowModel.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.toolBarButtonShowModel.ToolTipText = "Display persistent model";
			// 
			// toolBarButton3
			// 
			this.toolBarButton3.Name = "toolBarButton3";
			this.toolBarButton3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButtonReload
			// 
			this.toolBarButtonReload.ImageIndex = 6;
			this.toolBarButtonReload.Name = "toolBarButtonReload";
			this.toolBarButtonReload.ToolTipText = "Reload application domain(Ctrl+F4)";
			// 
			// toolBarButton5
			// 
			this.toolBarButton5.Name = "toolBarButton5";
			this.toolBarButton5.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButtonHelp
			// 
			this.toolBarButtonHelp.ImageIndex = 2;
			this.toolBarButtonHelp.Name = "toolBarButtonHelp";
			this.toolBarButtonHelp.ToolTipText = "Open Help Window (F1)";
			// 
			// imageListToolBar
			// 
			this.imageListToolBar.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageListToolBar.ImageStream")));
			this.imageListToolBar.TransparentColor = System.Drawing.Color.Magenta;
			this.imageListToolBar.Images.SetKeyName(0, "");
			this.imageListToolBar.Images.SetKeyName(1, "");
			this.imageListToolBar.Images.SetKeyName(2, "");
			this.imageListToolBar.Images.SetKeyName(3, "");
			this.imageListToolBar.Images.SetKeyName(4, "");
			this.imageListToolBar.Images.SetKeyName(5, "");
			this.imageListToolBar.Images.SetKeyName(6, "Refresh.ico");
			// 
			// treeView1
			// 
			this.treeView1.ContextMenuStrip = this.contextMenuStrip1;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Right;
			this.treeView1.ImageIndex = 0;
			this.treeView1.ImageList = this.imageListTreeView;
			this.treeView1.Location = new System.Drawing.Point(523, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = 0;
			this.treeView1.Size = new System.Drawing.Size(184, 498);
			this.treeView1.Sorted = true;
			this.treeView1.TabIndex = 0;
			this.toolTip1.SetToolTip(this.treeView1, "The available persistent object model");
			this.treeView1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.treeView1_KeyDown);
			// 
			// contextMenuStrip1
			// 
			this.contextMenuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripMenuItemCopyNodeText});
			this.contextMenuStrip1.Name = "contextMenuStripCopyNodeText";
			this.contextMenuStrip1.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
			this.contextMenuStrip1.Size = new System.Drawing.Size(210, 26);
			this.contextMenuStrip1.ItemClicked += new System.Windows.Forms.ToolStripItemClickedEventHandler(this.contextMenuStripCopyNodeText_ItemClicked);
			// 
			// toolStripMenuItemCopyNodeText
			// 
			this.toolStripMenuItemCopyNodeText.Name = "toolStripMenuItemCopyNodeText";
			this.toolStripMenuItemCopyNodeText.Size = new System.Drawing.Size(209, 22);
			this.toolStripMenuItemCopyNodeText.Text = "Copy to clipboard(Ctrl+C)";
			// 
			// imageListTreeView
			// 
			this.imageListTreeView.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageListTreeView.ImageStream")));
			this.imageListTreeView.TransparentColor = System.Drawing.Color.Magenta;
			this.imageListTreeView.Images.SetKeyName(0, "");
			this.imageListTreeView.Images.SetKeyName(1, "");
			// 
			// dataGridQueryResult
			// 
			this.dataGridQueryResult.DataMember = "";
			this.dataGridQueryResult.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dataGridQueryResult.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridQueryResult.Location = new System.Drawing.Point(0, 0);
			this.dataGridQueryResult.Name = "dataGridQueryResult";
			this.dataGridQueryResult.Size = new System.Drawing.Size(515, 282);
			this.dataGridQueryResult.TabIndex = 4;
			this.toolTip1.SetToolTip(this.dataGridQueryResult, "The Data retrieved by the OQL Query can be displayed here.");
			// 
			// textBoxSQL
			// 
			this.textBoxSQL.DetectUrls = false;
			this.textBoxSQL.Dock = System.Windows.Forms.DockStyle.Top;
			this.textBoxSQL.Location = new System.Drawing.Point(0, 0);
			this.textBoxSQL.Name = "textBoxSQL";
			this.textBoxSQL.ReadOnly = true;
			this.textBoxSQL.Size = new System.Drawing.Size(515, 112);
			this.textBoxSQL.TabIndex = 2;
			this.textBoxSQL.Text = "";
			this.toolTip1.SetToolTip(this.textBoxSQL, "The resulting SQL statement is displayed here.");
			// 
			// textBoxQuery
			// 
			this.textBoxQuery.AcceptsTab = true;
			this.textBoxQuery.AllowDrop = true;
			this.textBoxQuery.DetectUrls = false;
			this.textBoxQuery.Dock = System.Windows.Forms.DockStyle.Top;
			this.textBoxQuery.HideSelection = false;
			this.textBoxQuery.Location = new System.Drawing.Point(0, 0);
			this.textBoxQuery.Name = "textBoxQuery";
			this.textBoxQuery.Size = new System.Drawing.Size(515, 88);
			this.textBoxQuery.TabIndex = 0;
			this.textBoxQuery.Text = "SELECT * FROM  Extent AS x WHERE x.";
			this.toolTip1.SetToolTip(this.textBoxQuery, "Type your OQL Query here.\r\nExample:\r\n   SELECT * FROM OrderExtent AS o WHERE o.cu" +
					"stomer.firstName LIKE \'Ada*\' AND ... \r\nFor more information please refer to the " +
					"OQL reference or press F1.");
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "Text Files|*.txt|Query Files|*.qry|All Files|*.*";
			this.openFileDialog1.RestoreDirectory = true;
			this.openFileDialog1.ShowReadOnly = true;
			this.openFileDialog1.Title = "Open Query File";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.Filter = "Text Files|*.txt|Query Files|*.qry|All Files|*.*";
			// 
			// helpProvider1
			// 
			this.helpProvider1.HelpNamespace = "ms-help://OpenAccess/VS-Wizards/html/OQLQueryBrowser.htm";
			// 
			// panel1
			// 
			this.panel1.AllowDrop = true;
			this.panel1.Controls.Add(this.panel2);
			this.panel1.Controls.Add(this.splitter1);
			this.panel1.Controls.Add(this.treeView1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 28);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(707, 498);
			this.panel1.TabIndex = 5;
			// 
			// panel2
			// 
			this.panel2.AllowDrop = true;
			this.panel2.Controls.Add(this.panel3);
			this.panel2.Controls.Add(this.splitter2);
			this.panel2.Controls.Add(this.textBoxQuery);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(515, 498);
			this.panel2.TabIndex = 2;
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.panel4);
			this.panel3.Controls.Add(this.splitter3);
			this.panel3.Controls.Add(this.textBoxSQL);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel3.Location = new System.Drawing.Point(0, 96);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(515, 402);
			this.panel3.TabIndex = 2;
			// 
			// panel4
			// 
			this.panel4.Controls.Add(this.dataGridQueryResult);
			this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel4.Location = new System.Drawing.Point(0, 120);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(515, 282);
			this.panel4.TabIndex = 4;
			// 
			// splitter3
			// 
			this.splitter3.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter3.Location = new System.Drawing.Point(0, 112);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(515, 8);
			this.splitter3.TabIndex = 3;
			this.splitter3.TabStop = false;
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(0, 88);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(515, 8);
			this.splitter2.TabIndex = 1;
			this.splitter2.TabStop = false;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitter1.Location = new System.Drawing.Point(515, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(8, 498);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// QueryDialog
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(707, 526);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.toolBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "QueryDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "OQL Query Browser";
			this.Shown += new System.EventHandler(this.QueryDialog_Shown);
			this.contextMenuStrip1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dataGridQueryResult)).EndInit();
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.panel4.ResumeLayout(false);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == this.toolBarButtonOpen)
				QueryLoad();
			if (e.Button == this.toolBarButtonSave)
				QuerySave();
			if (e.Button == this.toolBarButtonSQL)
				QuerySQL();
			if (e.Button == this.toolBarButtonResult)
				QueryResult();
			if (e.Button == this.toolBarButtonHelp)
				QueryHelp();
            if (e.Button == this.toolBarButtonReload)
                Reload();
			if (e.Button == this.toolBarButtonShowModel)
				ShowModel();
		}

		private void QueryDialog_KeyDown(object sender, KeyEventArgs e)
		{
			switch (e.KeyData)
			{
				case Keys.F1:
					QueryHelp();
					break;
				case Keys.Control | Keys.O:
					QueryLoad();
					break;
				case Keys.Control | Keys.S:
					QuerySave();
					break;
				case Keys.Control | Keys.F5:
					QueryResult();
					break;
				case Keys.F5:
					QuerySQL();
					break;
                case Keys.Control | Keys.F4:
                    Reload();
                    break;
                case Keys.Escape:
					this.Close();
					break;
			}
		}

        private void contextMenuStripCopyNodeText_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            if (e.ClickedItem == this.toolStripMenuItemCopyNodeText)
            {
                CopyNodeText();
            }
        }

        private void treeView1_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyData)
            {
                case Keys.Control | Keys.C:
                    CopyNodeText();
                    break;
            }
        }

		private void QueryLoad ()
		{
			if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				StreamReader f = null;
				try
				{
					f = File.OpenText(this.openFileDialog1.FileName);
					this.textBoxQuery.Text = f.ReadToEnd();
				}
				finally
				{
					f.Close();
				}
			}
		}
		private void QuerySave ()
		{
			if (this.saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				StreamWriter f = null;
				try
				{
					f = File.CreateText(this.saveFileDialog1.FileName);
					f.Write(this.textBoxQuery.Text);
				}
				finally
				{
					if (f != null)
						f.Close();
				}
			}
		}
		private void QuerySQL ()
		{
			Cursor old = this.Cursor;
			try
			{
				this.Cursor = Cursors.WaitCursor;
				string query = this.textBoxQuery.Text;
				if (this.textBoxQuery.SelectedText != null && this.textBoxQuery.SelectedText != "")
					query = this.textBoxQuery.SelectedText;
				this.textBoxSQL.Text = this.oqlQueryBrowser.GetSQL(query);

				if (this.textBoxSQL.Text.StartsWith("SELECT "))
					this.textBoxSQL.ForeColor = SystemColors.WindowText;
				else
					this.textBoxSQL.ForeColor = Color.Red;
			}
			finally
			{
				this.Cursor = old;
			}
		}
		private void QueryResult ()
		{
			Cursor old = this.Cursor;
			try
			{
				this.Cursor = Cursors.WaitCursor;
				string query = this.textBoxQuery.Text;
				if (this.textBoxQuery.SelectedText != null && this.textBoxQuery.SelectedText != "")
					query = this.textBoxQuery.SelectedText;
				this.dataGridQueryResult.DataSource = null;
				this.textBoxSQL.Text = this.oqlQueryBrowser.GetResult(query,this.dataGridQueryResult);

				if (this.textBoxSQL.Text.StartsWith("SELECT "))
					this.textBoxSQL.ForeColor = SystemColors.WindowText;
				else
					this.textBoxSQL.ForeColor = Color.Red;
			}
			finally
			{
				this.Cursor = old;
			}
		}
		private void QueryHelp ()
		{
			Help.ShowHelp(this, this.helpProvider1.HelpNamespace);
		}

		private void ShowModel()
		{
			if (this.toolBarButtonShowModel.Pushed == false)
			{
				this.treeView1.Hide();
				this.splitter1.Hide();
			}
			else
			{
				Cursor old = this.Cursor;
				try
				{
					this.Cursor = Cursors.WaitCursor;
					string error = oqlQueryBrowser.FillTreeView(this.treeView1);
					if (error != null)
					{
						this.textBoxSQL.Text = error;
						this.textBoxSQL.ForeColor = Color.Red;
					}
				}
				finally
				{
					this.Cursor = old;
				}
				this.treeView1.Show();
				this.splitter1.Show();
			}
		}

        private void Reload()
        {
            QueryProperties props = AppDomain.CurrentDomain.GetData("Properties") as QueryProperties;
            if (props != null)
            {
                props.reload = true;
                props.oqlStatement = textBoxQuery.Text;
                props.modelVisible = treeView1.Visible;
                ControlPositioning.Save(this.treeView1, props.controlsPositioning);
                ControlPositioning.Save(this.textBoxSQL, props.controlsPositioning);
                ControlPositioning.Save(this.textBoxQuery, props.controlsPositioning);
                ControlPositioning.Save(this, props.controlsPositioning);
            }
            Close();
        }

        private void CopyNodeText()
        {
            if (treeView1.SelectedNode != null)
            {
                if (treeView1.SelectedNode.Level == 0)
                {
                    Clipboard.SetText(treeView1.SelectedNode.Text, TextDataFormat.Text);
                }
                else
                {
                    int idx = treeView1.SelectedNode.Text.LastIndexOf(" - ");
                    if (idx > 0)
                    {
                        Clipboard.SetText(treeView1.SelectedNode.Text.Remove(idx), TextDataFormat.Text);
                    }
                    else
                    {
                        Clipboard.SetText(treeView1.SelectedNode.Text, TextDataFormat.Text);
                    }
                }
            }
        }

		private OQLQueryBrowser oqlQueryBrowser;

		public OQLQueryBrowser Browser
		{
			set 
			{ 
				oqlQueryBrowser = value;
			}
		}

		private void textBoxQuery_DragEnter(object sender, DragEventArgs e)
		{
			// If the data is text, copy the data to the RichTextBox control.
			if(e.Data.GetDataPresent("Text")) {
				e.Effect = DragDropEffects.Copy;
			}
		}

		private void textBoxQuery_DragDrop(object sender, DragEventArgs e) 
		{
			// Paste the text into the RichTextBox where at selection location.
			string text = e.Data.GetData("System.String", true).ToString();
			if (text != null && text.Length > 0)
			{
				if (this.textBoxQuery.SelectionLength == 0)
				{	// check if we should put a '.' before the text is entered
					char t = text[0];
					if (t != ' ' && t != '.')
					{
						int selStart = this.textBoxQuery.SelectionStart;
						string old = this.textBoxQuery.Text;
						if (selStart > 1 && selStart <= old.Length)
						{
							char p = old[selStart-1];
							if (p != ' ' && p != '.')
								text = "."+text;
						}
					}
				}
				this.textBoxQuery.SelectedText = text;
			}
		}

		private void treeView1_ItemDrag(object sender, ItemDragEventArgs e)
		{
			TreeNode node = e.Item as TreeNode;
			if (node != null)
			{
				string text = node.Text;
				text = text.Split(new char[]{' '},2)[0];
				if (text.Length > 0)
					treeView1.DoDragDrop(text, DragDropEffects.Copy);
			}
		}

        private void QueryDialog_Shown(object sender, EventArgs e)
        {
            QueryProperties props = AppDomain.CurrentDomain.GetData("Properties") as QueryProperties;
            if (props != null && !string.IsNullOrEmpty(props.oqlStatement))
            {
                textBoxQuery.Text = props.oqlStatement;
                if (props.modelVisible)
                {
                    this.toolBarButtonShowModel.Pushed = true;
                    this.ShowModel();
                }
                ControlPositioning.Load(this, props.controlsPositioning);
                ControlPositioning.Load(this.treeView1, props.controlsPositioning);
                ControlPositioning.Load(this.textBoxQuery, props.controlsPositioning);
                ControlPositioning.Load(this.textBoxSQL, props.controlsPositioning);
            }
        }
	}
}
